//
//  TKAppSkin.h
//  ThemeKit
//
//  Created by Colin Cornaby on 2/28/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "TKMDManagedObject.h"

@interface TKAppSkin : TKMDManagedObject {

}

//This is a DRM accessor method. Don't worry about this for now.
-(NSData *)currentDRMKey;
//App Skin name mutator/accessor
-(NSString *)name;
-(void)setName:(NSString *)theName;
//Get all resources from a app skin of a certain type.
//Resource types share the names of the various classes
-(NSArray *)getResourcesForType:(NSString *)resType;
//Pull from Finder resource file data.
-(void)pullFromFinderResourceData:(NSString *)resourceFilePath;
//Remove the resource from the app skin
-(void)removeAppSkinResource:(id)resource;
//Add the resource into the app skin
-(id)addAppSkinResource:(id)resource;
//Write out a theme safe Finder resource file
-(void)writeFinderResourceFile:(NSString *)location;
-(void)writeExtrasFileAtPath:(NSString *)path withEndianness:(TKEndianness)endianness writeComplete:(BOOL)writeCompleteFile;
-(void)writeExtrasFileAtPath:(NSString *)path withEndianness:(TKEndianness)endianness;
-(void)writeExtrasFileAtPath:(NSString *)location;
-(void)pullFromExtrasResourceData:(NSString *)resourceFileData;
-(NSArray *)pullImagesFromResourceFile:(NSString *)path forTypes:(NSArray *)types;
-(void)setAppIdentifier:(NSString *)appIdentifier;
-(NSString *)appIdentifier;
-(void)setIcon:(NSImage *)theIcon;
-(NSData *)icon;
-(NSArray *)getResourcesForType:(NSString *)resType withSortDescriptors:(NSArray *)descriptors;
-(void)pullFromExtrasResourceData:(NSString *)resourceFileData withEndianness:(TKEndianness)endianness;

@end
